/*******************************************************************************
*
 * Copyright (c) 2013 - 2016, Freescale Semiconductor, Inc.
 * Copyright 2016-2021 NXP
 *
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted provided that the following conditions are met:
 *
 * o Redistributions of source code must retain the above copyright notice, this list
 *   of conditions and the following disclaimer.
 * o Redistributions in binary form must reproduce the above copyright notice, this
 *   list of conditions and the following disclaimer in the documentation and/or
 *   other materials provided with the distribution.
 *
 * o Neither the name of the copyright holder nor the names of its
 *   contributors may be used to endorse or promote products derived from this
 *   software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 * ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
* 
*
****************************************************************************//*!
*
* @brief  Dead Time Compensation Custom Calculation
* 
*******************************************************************************/

#ifndef _GMCLIB_DTCOMPLUT1D_F16_H_
#define _GMCLIB_DTCOMPLUT1D_F16_H_

#if defined(__cplusplus) 
extern "C" {
#endif
  
/****************************************************************************
* Includes
****************************************************************************/  
#include "mlib.h"
#include "gflib.h"  
#include "gmclib_types.h" 
  
/******************************************************************************
* Macros 
******************************************************************************/   
#define GMCLIB_DTCompLut1D_F16_C(psIABC, psUAlBe, f16U_DCB, psParam, psUAlBeDtComp) \
        GMCLIB_DTCompLut1D_F16_FC(psIABC, psUAlBe, f16U_DCB, psParam, psUAlBeDtComp)

/******************************************************************************
* Types 
******************************************************************************/     
typedef struct
{
    const frac16_t *pf16Table;
    uint16_t u16TableSize;
} GMCLIB_DTCOMPLUT1D_T_F16;

/****************************************************************************
* Exported function prototypes
****************************************************************************/
extern void GMCLIB_DTCompLut1D_F16_FC(const GMCLIB_3COOR_T_F16 *psIABC,
                                      const GMCLIB_2COOR_ALBE_T_F16 *psUAlBe,
                                      frac16_t f16UDCBus,
                                      const GMCLIB_DTCOMPLUT1D_T_F16 *psParam,
                                      GMCLIB_2COOR_ALBE_T_F16 *psUAlBeDTComp);

#if defined(__cplusplus) 
}
#endif

#endif /* _GMCLIB_DTCOMPLUT1D_F16_H_ */
